variables:
  DOCKER_HOST: tcp://docker:2375
  DOCKER_TLS_CERTDIR: ""
  #DOCKER_TLS_VERIFY: 0

stages:
  - fetch-version
  - build
  - test
  - release

fetch-semantic-version:
  image: node:13
  stage: fetch-version
  only:
    refs:
    - master
    - main
    - alpha
    - beta
    - /^(([0-9]+)\.)?([0-9]+)\.x/ # This matches maintenance branches
    - /^([0-9]+)\.([0-9]+)\.([0-9]+)(?:-([0-9A-Za-z-]+(?:\.[0-9A-Za-z-]+)*))?(?:\+[0-9A-Za-z-]+)?$/ # This matches pre-releases
  script:
    - make install-deps
    - npx semantic-release --generate-notes false --dry-run
  artifacts:
    paths:
    - VERSION.txt

generate-non-semantic-version:
  image: node:13
  stage: fetch-version
  except:
    refs:
    - master
    - main
    - alpha
    - beta
    - /^(([0-9]+)\.)?([0-9]+)\.x/ # This matches maintenance branches
    - /^([0-9]+)\.([0-9]+)\.([0-9]+)(?:-([0-9A-Za-z-]+(?:\.[0-9A-Za-z-]+)*))?(?:\+[0-9A-Za-z-]+)?$/ # This matches pre-releases
  script:
    - echo build-$CI_PIPELINE_ID > VERSION.txt
  artifacts:
    paths:
    - VERSION.txt

# build-cnab:
#   image: 
#     name: wearep3r/docker:latest
#     entrypoint: [""]
#   stage: build
#   services:
#     - docker:20.10.3-dind
#   only:
#     refs:
#     - master
#     - alpha
#     # This matches maintenance branches
#     - /^(([0-9]+)\.)?([0-9]+)\.x/
#     # This matches pre-releases
#     - /^([0-9]+)\.([0-9]+)\.([0-9]+)(?:-([0-9A-Za-z-]+(?:\.[0-9A-Za-z-]+)*))?(?:\+[0-9A-Za-z-]+)?$/ 
#   variables:
#     IMAGE_TAG: $CI_REGISTRY_IMAGE:$CI_COMMIT_REF_SLUG
#   # before_script:
#   #   - apk add bash curl
#   #   - curl https://cdn.porter.sh/latest/install-linux.sh | bash
#   script:
#     - git describe --abbrev=0 --tags
#     # https://stackoverflow.com/questions/6594085/remove-first-character-of-a-string-in-bash/20195713
#     - export SEMANTIC_VERSION=$(cat VERSION.txt || git describe --abbrev=0 --tags | cut -c2-)
#     - echo "VERSION=${SEMANTIC_VERSION}"
#     - echo "$DOCKER_HUB_PASSWORD" | docker login --username $DOCKER_HUB_USER --password-stdin
#     - make porter-update-version
#     #- sed -i -r "s|[[:digit:]]+\.[[:digit:]]+\.[[:digit:]]+|${SEMANTIC_VERSION}|g" porter.yaml
#     - make porter-build
#     - make porter-publish

release:
  image: node:13
  stage: release
  only:
    refs:
    - master
    - main
    - alpha
    - beta
    # This matches maintenance branches
    - /^(([0-9]+)\.)?([0-9]+)\.x/
    # This matches pre-releases
    - /^([0-9]+)\.([0-9]+)\.([0-9]+)(?:-([0-9A-Za-z-]+(?:\.[0-9A-Za-z-]+)*))?(?:\+[0-9A-Za-z-]+)?$/ 
  script:
    - touch CHANGELOG.md
    - make install-deps
    - export SEMANTIC_VERSION=$(cat VERSION.txt || git describe --abbrev=0 --tags | cut -c2-)
    - echo "VERSION=${SEMANTIC_VERSION}"
    #- make porter-update-version
    - make release
  artifacts:
    paths:
    - CHANGELOG.md